/*
 * Created on 03-dic-2004
 *
 * Code of the alarm agent
 */
package agents;


import gui.*;
import alice.tucson.api.*;
import alice.logictuple.*;

public class AlarmAgent extends Agent {

    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    private static GuiSwing myGui = new GuiSwing();
    private TupleCentreId Tid;
    private float AvgWind=0, AvgRain=0, AvgBaro=0;
    private float VarWind=0, VarRain=0, VarBaro=0;
    
               
    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param gui the gui used
     * @param tid the tuple center used
     * @throws TucsonException
     */
    public AlarmAgent(AgentId arg0, GuiSwing gui, TupleCentreId tid) throws TucsonException {
        super(arg0);
        myGui = gui;
        Tid = tid;  
    }

    public void body(){ 
        while (true){
            try { 
                
		        startAnalisis();
		        
		       } catch (Exception ex){System.out.println(ex);}
        }  
    }
    
    /**
     * This void start the analisis of the Forecasts agent
     * and interact with the tuple center forecasts
     */
    public void startAnalisis(){
        String[] fields = new String[10];
	    
	    try { 
	        TucsonContext context = Tucson.enterDefaultContext();
	        
	            LogicTuple WindAlarm = inp(Tid, new LogicTuple("windAlarm",
	                    new Var("Vento")));
	            
	            if (WindAlarm==null){
	                fields[0]="0";
	                } else {
	                fields[0]=WindAlarm.getArg(0).toString();
	                }
	            
	            LogicTuple WindRafficaAlarm = inp(Tid, new LogicTuple("windRafficaAlarm",
	                    new Var("Raffica")));
	            
	            if (WindRafficaAlarm==null){
	                fields[1]="0";
	                } else {
	                fields[1]=WindRafficaAlarm.getArg(0).toString();
	                }
	            
	            LogicTuple RainAlarm = inp(Tid, new LogicTuple("rainAlarm",
	                    new Var("Pioggia")));

	            if (RainAlarm==null){
	                fields[2]="0";
	                } else {
	                fields[2]=RainAlarm.getArg(0).toString();
	                }
	            
	            LogicTuple RainAlluvioneAlarm = inp(Tid, new LogicTuple("rainAlluvioneAlarm",
	                    new Var("Alluvione")));
	            
	            if (RainAlluvioneAlarm==null){
	                fields[3]="0";
	                } else {
	                fields[3]=RainAlluvioneAlarm.getArg(0).toString();
	                }
	            
	            LogicTuple BaroAlarm = inp(Tid, new LogicTuple("baroAlarm",
	                    new Var("Pressione")));

	            if (BaroAlarm==null){
	                fields[4]="0";
	                } else {
	                fields[4]=BaroAlarm.getArg(0).toString();
	                }
	            
	            LogicTuple BaroSbalzoAlarm = inp(Tid, new LogicTuple("baroSbalzoAlarm",
	                    new Var("SbalzoPressione")));
	            
	            if (BaroSbalzoAlarm==null){
	                fields[5]="0";
	                } else {
	                fields[5]=BaroSbalzoAlarm.getArg(0).toString();
	                }
	            
	           
	            
	            
	            
	            
	            
	            
	            
	            myGui.setField(16, fields);
	            
	            
	    } catch (Exception ex){System.out.println(ex);}

    }
    
    
   
    
}
