/*
 * Created on 18-dic-2004
 *
 * Code of the BaroAnalyzer agent
 */
package agents;


import alice.tucson.api.*;
import alice.logictuple.*;

import java.lang.Float;

public class BaroAnalyzerAgent extends Agent {

    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    private TupleCentreId Tid;

    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param tc the tuple center used
     * @throws TucsonException
     */
    public BaroAnalyzerAgent(AgentId arg0, TupleCentreId tid) throws TucsonException {
        super(arg0);
        Tid = tid;  
    }

    public void body(){ 
        while (true){
            try { 
                startAnalisis();
		    } catch (Exception ex){System.out.println(ex);}
        }  
    }
    
    /**
     * This void start the analisis of the barometer analyzer agent
     * and interact with the tuple center forecasts
     */
    public void startAnalisis(){
        	
		    String[] fields = new String[10];
		    int timesToReadBaro;
		    Float AvgSpeed;
		    float AvgBaroSpeed=0;
		    int var = 5;
		    float[] currValue = new float[var];
		    Float currValueFloat;
		    int timesToReadBaroMedia=0;
		    float avgBaro=0, avgBaroVarianza=0;
		    
		
		    try { 
		        TucsonContext context = Tucson.enterDefaultContext();
		        for (timesToReadBaro=0; timesToReadBaro<var; timesToReadBaro++ ){
		            LogicTuple Barometro = in(Tid, new LogicTuple("inConditions",
		    				new Var("Data"),
		    				new Var("OutTemp"),
		    				new Var("RelHum"),
		    				new Var("DewPoint"),
		    				new Var("BaroPress"),
		    				new Var("Tendency"),
		    				new Var("SeaLevel")));

		            
		            if (Barometro==null){} else {
		                currValueFloat = new Float(Barometro.getArg(4).toString());
		                currValue[timesToReadBaroMedia]=currValueFloat.floatValue();
		                }
		        }
		        
		        for (timesToReadBaroMedia=0; timesToReadBaroMedia<var; timesToReadBaroMedia++ ){
		            avgBaro+=currValue[timesToReadBaroMedia];
		        }
		        avgBaro = avgBaro/var;
		        
		        for (timesToReadBaroMedia=0; timesToReadBaroMedia<var; timesToReadBaroMedia++ ){
		            avgBaroVarianza+=(currValue[timesToReadBaroMedia]-avgBaro);
		        }
		        avgBaroVarianza = avgBaroVarianza/var;
		        
		
		        context.out(Tid, new LogicTuple("baroTrend",new Value(avgBaro),new Value(avgBaroVarianza)));
		    } catch (Exception ex){System.out.println(ex);}
		    
		    
	        
	        
	        
		    
		    
		}

    
    
    
   
    
}