/*
 * Created on 18-dic-2004
 *
 * Code of the RainAnalyzer agent
 */
package agents;


import alice.tucson.api.*;
import alice.logictuple.*;

import java.lang.Float;

public class RainAnalyzerAgent extends Agent {

    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    
    private TupleCentreId Tid;

    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param tid the tuple center used
     * @throws TucsonException
     */
    public RainAnalyzerAgent(AgentId arg0, TupleCentreId tid) throws TucsonException {
        super(arg0);
        Tid = tid;  
    }

    public void body(){ 
        while (true){
            try { 
                startAnalisis();
		    } catch (Exception ex){System.out.println(ex);}
        }  
    }
    
    /**
     * This void start the analisis of the rain analyzer agent
     * and interact with the tuple center forecasts
     */
    public void startAnalisis(){
        	
		    String[] fields = new String[10];
		    int timesToReadRain;
		    Float AvgSpeed;
		    float AvgRainSpeed=0;
		    int var = 5;
		    int var2 = 5;
		    float[] currValue = new float[var];
		    Float currValueFloat;
		    int timesToReadRainMedia=0;
		    float avgRain=0, avgRainVarianza=0;
		    
		
		    try { 
		        TucsonContext context = Tucson.enterDefaultContext();
		        for (timesToReadRain=0; timesToReadRain<var; timesToReadRain++ ){
		            LogicTuple Pioggia = in(Tid, new LogicTuple("pioggia",
		    				new Var("Data"),
		    				new Var("RainRate"),
		    				new Var("RainTotal"),
		    				new Var("RainTotalYest")));

		            
		            if (Pioggia==null){} else {
		                currValueFloat = new Float(Pioggia.getArg(1).toString());
		                currValue[timesToReadRainMedia]=currValueFloat.floatValue();
		                }
		        }
		        
		        for (timesToReadRainMedia=0; timesToReadRainMedia<var; timesToReadRainMedia++ ){
		            avgRain+=currValue[timesToReadRainMedia];
		        }
		        avgRain = avgRain/var;
		        
		        for (timesToReadRainMedia=0; timesToReadRainMedia<var; timesToReadRainMedia++ ){
		            avgRainVarianza+=(currValue[timesToReadRainMedia]-avgRain);
		        }
		        avgRainVarianza = avgRainVarianza/var;
		        
		
		        context.out(Tid, new LogicTuple("rainTrend",new Value(avgRain),new Value(avgRainVarianza)));
		    } catch (Exception ex){System.out.println(ex);}
		    
		    
	        
	        
	        
		    
		    
		}

    
    
    
   
    
}