/*
 * Created on 03-dic-2004
 *
 * Code of the acquire ViewExtra
 */
package agents;


import gui.*;
import alice.tucson.api.*;
import alice.logictuple.*;

public class ViewExtraAgent extends Agent {
    
    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    private static GuiSwing myGui = new GuiSwing();
    TupleCentreId Tid;
    
    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param gui the gui used
     * @param tid the tuple center used
     * @throws TucsonException
     */
    public ViewExtraAgent(AgentId arg0, GuiSwing gui, TupleCentreId tid) throws TucsonException {
        super(arg0);
        myGui = gui;
        Tid = tid;
    }

    public void body(){ 
        String[] fieldToSend = new String[10];
        while (true){
        try { 
        LogicTuple ExtraSensor = in(Tid, new LogicTuple("extraSensor",
				new Var("Data"),
				new Var("OutTemp"),
				new Var("RelHum"),
				new Var("DewPoint")));
        
        fieldToSend[0]= ExtraSensor.getArg(1).toString();
        fieldToSend[1]= ExtraSensor.getArg(2).toString();
        fieldToSend[2]= ExtraSensor.getArg(3).toString();
        
        if (ExtraSensor==null){} else { 
            myGui.setField(3, fieldToSend);
            myGui.updatePacketCount();
            myGui.updateCurrentPacketTime(ExtraSensor.getArg(0).toString());
            }
        
        } catch (Exception ex){System.out.println(ex);}
    }
    }
}
