/*
 * Created on 03-dic-2004
 *
 * Code of the ViewIn conditions agent
 */
package agents;


import gui.*;
import alice.tucson.api.*;
import alice.logictuple.*;

public class ViewInAgent extends Agent {
    
    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    private static GuiSwing myGui = new GuiSwing();
    TupleCentreId Tid;
    
    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param gui the gui used
     * @param tid the tuple center used
     * @throws TucsonException
     */
    public ViewInAgent(AgentId arg0, GuiSwing gui, TupleCentreId tid) throws TucsonException {
        super(arg0);
        myGui = gui;
        Tid = tid;
    }

    public void body(){ 
        String[] fieldToSend = new String[10];
        while (true){
        try { 
        LogicTuple InConditions = in(Tid, new LogicTuple("inConditions",
				new Var("Data"),
				new Var("OutTemp"),
				new Var("RelHum"),
				new Var("DewPoint"),
				new Var("BaroPress"),
				new Var("Tendency"),
				new Var("SeaLevel")));
        
        fieldToSend[0]= InConditions.getArg(1).toString();
        fieldToSend[1]= InConditions.getArg(2).toString();
        fieldToSend[2]= InConditions.getArg(3).toString();
        fieldToSend[3]= InConditions.getArg(4).toString();
        fieldToSend[4]= InConditions.getArg(5).toString();
        fieldToSend[5]= InConditions.getArg(6).toString();
        
        if (InConditions==null){} else { 
            myGui.setField(5, fieldToSend);
            myGui.updatePacketCount();
            myGui.updateCurrentPacketTime(InConditions.getArg(0).toString());
            }
        
        } catch (Exception ex){System.out.println(ex);}
    }
    }
}
