/*
 * Created on 03-dic-2004
 *
 * Code of the ViewStatus agent
 */
package agents;


import gui.*;
import alice.tucson.api.*;
import alice.logictuple.*;

public class ViewStatusAgent extends Agent {
    
    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    private static GuiSwing myGui = new GuiSwing();
    TupleCentreId Tid;
    
    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param gui the gui used
     * @param tid the tuple center used
     * @throws TucsonException
     */
    public ViewStatusAgent(AgentId arg0, GuiSwing gui, TupleCentreId tid) throws TucsonException {
        super(arg0);
        myGui = gui;
        Tid = tid;
    }

    public void body(){ 
        String[] fieldToSend = new String[10];
        while (true){
        try {        
        LogicTuple HourlyStatusReport = in(Tid, new LogicTuple("hourlyStatusReport",
				new Var("Hour"),
				new Value("time",
				        new Var("Day"),
				        new Var("Month"),
				        new Var("Year"))
				        )
				        );
        fieldToSend[0]= HourlyStatusReport.getArg(0).toString();
        fieldToSend[1]= HourlyStatusReport.getArg(1).getArg(0).toString();
        fieldToSend[2]= HourlyStatusReport.getArg(1).getArg(1).toString();
        fieldToSend[3]= HourlyStatusReport.getArg(1).getArg(2).toString();
        
        if (HourlyStatusReport==null){} else {
            myGui.setField(15, fieldToSend);
            myGui.updatePacketCount();
            myGui.updateCurrentPacketTime(HourlyStatusReport.getArg(0).toString());
            }
        
        } catch (Exception ex){System.out.println(ex);}
    }
    }
}
