/*
 * Created on 03-dic-2004
 *
 * Code of the ViewWind agent
 */
package agents;


import gui.*;
import alice.tucson.api.*;
import alice.logictuple.*;

public class ViewWindAgent extends Agent {
    
    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    private static GuiSwing myGui = new GuiSwing();
    TupleCentreId Tid;
    
    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param gui the gui used
     * @param tid the tuple center used
     * @throws TucsonException
     */
    public ViewWindAgent(AgentId arg0, GuiSwing gui, TupleCentreId tid) throws TucsonException {
        super(arg0);
        myGui = gui;
        Tid = tid;
    }

    public void body(){ 
        String[] fieldToSend = new String[10];
        
        while (true){
        try { 
        LogicTuple Vento = in(Tid, new LogicTuple("vento",
                new Var("Data"),
                new Var("GustDirection"),
                new Var("GustSpeed"),
                new Var("AverageSpeed"),
                new Var("WindChill")));
        
        fieldToSend[0]= Vento.getArg(1).toString();
        fieldToSend[1]= Vento.getArg(2).toString();
        fieldToSend[2]= Vento.getArg(3).toString();
        fieldToSend[3]= Vento.getArg(4).toString();
        
        if (Vento==null){} else {
            myGui.setField(0, fieldToSend);
            myGui.updatePacketCount();
            myGui.updateCurrentPacketTime(Vento.getArg(0).toString());
            }
        
        } catch (Exception ex){System.out.println(ex);}
    }
    }
}
