/*
 * Created on 18-dic-2004
 *
 * Code of the WindAnalyzer agent
 */
package agents;

import alice.tucson.api.*;
import alice.logictuple.*;
import java.lang.Float;

public class WindAnalyzerAgent extends Agent {

    /**
     * @author Pazzaglia Marco
     * @version 1.0
     */
    private TupleCentreId Tid;

    /**
     * Default constructor of the class
     * @param arg0 AgentId - the id of the Agent
     * @param gui the gui used
     * @param tid the tuple center used
     * @throws TucsonException
     */
    public WindAnalyzerAgent(AgentId arg0, TupleCentreId tid) throws TucsonException {
        super(arg0);
        Tid = tid;  
    }

    public void body(){ 
        while (true){
            try { 
		        startAnalisis();
		    } catch (Exception ex){System.out.println(ex);}
        }  
    }
    
    /**
     * This void start the analisis of the wind analyzer agent
     * and interact with the tuple center forecasts
     */
    public void startAnalisis(){
        	
		    String[] fields = new String[10];
		    int timesToReadWind;
		    Float AvgSpeed;
		    float AvgWindSpeed=0;
		    int var = 5;
		    float[] currValue = new float[var];
		    Float currValueFloat;
		    int timesToReadWindMedia;
		    float avgWind=0, avgWindVarianza=0;
		    
		for (timesToReadWindMedia=0; timesToReadWindMedia<var; timesToReadWindMedia++ ){
		    try { 
		        TucsonContext context = Tucson.enterDefaultContext();
		        for (timesToReadWind=0; timesToReadWind<var; timesToReadWind++ ){
		            LogicTuple Vento = in(Tid, new LogicTuple("vento",
		                    new Var("Data"),
		                    new Var("GustDirection"),
		                    new Var("GustSpeed"),
		                    new Var("AverageSpeed"),
		                    new Var("WindChill")));

		            
		            if (Vento==null){} else {
		                AvgSpeed = new Float(Vento.getArg(3).toString());
		                AvgWindSpeed+=AvgSpeed.floatValue();
		                }
		        }
		        AvgWindSpeed = AvgWindSpeed/var;
		        
		        context.out(Tid, new LogicTuple("ventoMedia",new Value(AvgWindSpeed)));
		        
		    } catch (Exception ex){System.out.println(ex);}
		    
		    
		    try { 
		        TucsonContext context = Tucson.enterDefaultContext();
		        
		            LogicTuple VentoMedia = in(Tid, new LogicTuple("ventoMedia",
		                    new Var("Media")));
		            
		            if (VentoMedia==null){} else {
		                currValueFloat = new Float(VentoMedia.getArg(0).toString());
		                currValue[timesToReadWindMedia]=currValueFloat.floatValue();
		                //tieni 5 rilevamenti 
		                
		                }
		    } catch (Exception ex){System.out.println(ex);}
		    
		}
//		    	//se il trend  superiore a X lancia 1 avviso altrimenti tutto ok
	            //se l'avviso  superiore alla soglia di allarme lancia un allarme altrimenti notifica
		        for (timesToReadWindMedia=0; timesToReadWindMedia<var; timesToReadWindMedia++ ){
		            avgWind+=currValue[timesToReadWindMedia];
		        }
		        avgWind = avgWind/var;
		        
		        for (timesToReadWindMedia=0; timesToReadWindMedia<var; timesToReadWindMedia++ ){
		            avgWindVarianza+=(currValue[timesToReadWindMedia]-avgWind);
		        }
		        avgWindVarianza = avgWindVarianza/var;
		        try {
		        TucsonContext context = Tucson.enterDefaultContext();
	            context.out(Tid, new LogicTuple("windTrend",new Value(avgWind),new Value(avgWindVarianza)));
	            
	            System.out.println("\n"+currValue.toString()+"\n"+avgWind+"\n"+avgWindVarianza);
		        } catch (Exception ex){System.out.println(ex);}
    }
    
    
   
    
}